﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.3
@EndOfDesignText@
#DesignerProperty: Key: PointerAngle, DisplayName: Pointer Angle Deg, FieldType: Float, DefaultValue: 45
#DesignerProperty: Key: AnimationTime, DisplayName: Pointer Time Constant (sec's), FieldType: Int, DefaultValue: 5
#DesignerProperty: Key: EnableAnimation, DisplayName: Enable Animation, FieldType: Boolean, DefaultValue: True

#if IMAGE_SELECT
#DesignerProperty: Key: pointerFileName, DisplayName: Compass Pointer Filename, FieldType: String, DefaultValue: NULL
#DesignerProperty: Key: scaleFilename, DisplayName: Compass Scale Filename, FieldType: String, DefaultValue: NULL
'#DesignerProperty: Key: pointerFileName, Compass Pointer File Name: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Text color
'#DesignerProperty: Key: Max, DisplayName: Max, FieldType: Int, DefaultValue: 100, Description: Sets the max value.
#end if

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore       ####### Why does this have an ignore comment #######
	Private iVcompScale As B4XView   'Image view of compass pointer
	Private iVpointer As B4XView	 'Image view of compass scale
	Public Tag As Object			 'Should this be public or private??	
	Private animationTime As Int
	Private angleValue As Double
	Private xValue As Double
	Private xValueFilt As Double
	Private yValue As Double
	Private yValueFilt As Double
	Private angleValueFilt As Double
	Private angleRecip As Double
	Private enableAnimation As Boolean
	
	Private TimerAnimation As Timer
	Private alpha As Double
	Dim const ts As Double = 100
	
#if IMAGE_SELECT		
	Private pointerFileName As String
	Private scaleFilename As String
	
	Private pointerImage As Image
	Private scaleImage As ImageView
#end if

End Sub


Public Sub Initialize (Callback As Object, EventName As String)
	mEventName 	= EventName
	mCallBack 	= Callback

End Sub


'-------------------------------------------------------------------------------------------------------------------------
'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me 


	animationTime = Props.GetDefault("AnimationTime", 500)
	angleValue = Props.GetDefault("PointerAngle", 0.0)
	angleValueFilt = angleValue


#if IMAGE_SELECT	
	Dim ivTemp As ImageView = iVpointer
	Dim bm As B4XBitmap 
	pointerFileName = Props.GetDefault("pointerFileName", 500)
	
	If File.Exists(File.DirApp, pointerFileName) Then
		Try 
			pointerImage.Initialize(File.DirApp, pointerFileName)
			ivTemp. = pointerImage
			iVpointer.SetBitmap(pointerImage)
		Catch
			Log(LastException)
		End Try
	End If
	
	scaleFilename = Props.GetDefault("scaleFilename", 0.0)
#end if	

  	' Dim clr As Int = xui.PaintOrColorToColor(Props.Get("TextColor")) 'Example of getting a color value from Props
	mBase.LoadLayout("compass_cv")
	iVpointer.Visible = True
	
	' Set up vector animation
	alpha = ts / 1000 / animationTime
	TimerAnimation.Initialize("animationUpdate", ts)
	xValue = CosD(angleValue)
	xValueFilt = xValue
	yValue = SinD(angleValue)
	yValueFilt = yValue 
End Sub


'-------------------------------------------------------------------------------------------------------------------------
public Sub setAngle(angleDeg As Double)

	angleValue = angleDeg
	
	If animationTime <= 0 Or enableAnimation = False Then
		iVpointer.Rotation = angleValue
	End If

End Sub


'-------------------------------------------------------------------------------------------------------------------------
public Sub getAngle() As Double
	Return angleValue
End Sub


'-------------------------------------------------------------------------------------------------------------------------
public Sub setReciprocalAngle(angleDeg As Double)
	If angleDeg >= 180 Then	
		angleRecip  = angleDeg - 180
	Else 
		angleRecip = angleDeg + 180
	End If
	iVpointer.SetRotationAnimated(animationTime, angleRecip)
End Sub


'-------------------------------------------------------------------------------------------------------------------------
public Sub getAngleReciprocal() As Double
	Return angleRecip
End Sub


'-------------------------------------------------------------------------------------------------------------------------
Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub


'-------------------------------------------------------------------------------------------------------------------------
public Sub getAnimationTime() As Int
	Return animationTime
End Sub


'-------------------------------------------------------------------------------------------------------------------------
public Sub setAnimationTime(animationTimeVal As Int)
	animationTime = animationTimeVal
End Sub


'-------------------------------------------------------------------------------------------------------------------------
public Sub animationUpdate_Tick
	xValue = CosD(angleValue)
	yValue = SinD(angleValue)
	xValueFilt = xValueFilt + alpha * (xValue - xValueFilt)
	yValueFilt = yValueFilt	+ alpha * (yValue - yValueFilt)
	angleValueFilt = ATan2D(yValueFilt, xValueFilt)
	iVpointer.Rotation = angleValueFilt
'	Log("Angle Filt = " & angleValueFilt &  "   "  & DateTime.Time(DateTime.Now))
End Sub


'-------------------------------------------------------------------------------------------------------------------------
public Sub getAnimationEnable() As Boolean
	Return enableAnimation
End Sub

'-------------------------------------------------------------------------------------------------------------------------


public Sub setAnimationEnable(anEnable As Boolean)
	enableAnimation = anEnable
	If enableAnimation = True Then
		TimerAnimation.Enabled = True
	Else	
		TimerAnimation.Enabled = False
	End If
End Sub